import request from '@/utils/request';
import type {ApiResult, PageResult} from '@/api/index';
import type {User, UserParam} from './model';
import {SERVER_API_URL} from "@/utils/server";

/**
 * 分页查询用户
 */
export async function pageUsers(params: UserParam) {
  const res = await request.get<ApiResult<PageResult<User>>>(
    '/system/user/page',
    {params}
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询用户列表
 */
export async function listUsers(params?: UserParam) {
  const res = await request.get<ApiResult<User[]>>(
    '/system/user',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询用户列表
 */
export async function getStaffs(params?: UserParam) {
  const res = await request.get<ApiResult<User[]>>(
    '/system/user',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询用户列表
 */
export async function getCompanyList(params?: UserParam) {
  const res = await request.get<ApiResult<User[]>>(
    '/system/user',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询用户
 */
export async function getUser(id: number) {
  const res = await request.get<ApiResult<User>>(
    '/system/user/' + id,
    {}
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加用户
 */
export async function addUser(data: User) {
  const res = await request.post<ApiResult<unknown>>(
    '/system/user',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改用户
 */
export async function updateUser(data: User) {
  const res = await request.put<ApiResult<unknown>>(
    SERVER_API_URL + '/system/user',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除用户
 */
export async function removeUser(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/system/user/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除用户
 */
export async function removeUsers(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/system/user/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改用户状态
 */
export async function updateUserStatus(userId?: number, status?: number) {
  const res = await request.put<ApiResult<unknown>>(
    '/system/user/status',
    {
      userId,
      status
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改推荐状态
 */
export async function updateUserRecommend(form) {
  const res = await request.put<ApiResult<unknown>>(
    '/system/user/recommend',
    form
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 重置用户密码
 */
export async function updateUserPassword(userId?: number, password = '123456') {
  const res = await request.put<ApiResult<unknown>>(
    '/system/user/password',
    {
      userId,
      password
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 导入用户
 */
export async function importUsers(file: File) {
  const formData = new FormData();
  formData.append('file', file);
  const res = await request.post<ApiResult<unknown>>(
    '/system/user/import',
    formData
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 检查用户是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    '/system/user/existence',
    {
      params: {field, value, id}
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 统计用户余额
 */
export async function countUserBalance(params?: UserParam) {
  const res = await request.get<ApiResult<unknown>>(
    '/system/user/countUserBalance',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}


/**
 * 选择管理员账号登录
 * @param params
 */
export async function listAdminsByPhoneAll(params?: UserParam) {
  const res = await request.get<ApiResult<User[]>>(
    '/system/user/listAdminsByPhoneAll',
    params
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
